module Toni
  module PermissionMatcher

    class Base

      include HasMatcher

      attr_reader :method_name, :is_attr

      def initialize(method_name, matcher, is_attr = false)
        @method_name  = method_name
        @matcher      = matcher
        @is_attr      = is_attr
      end

      def matches?(object)
        unless object.respond_to?(method_name)
          raise Toni::NoMethodForMatcherError.new("#{method_name} is not defined for #{object.inspect}")
        end
        matcher.matches?(object.send(method_name))
      end

      def filter_condition
        return nil unless is_attr
        super
      end

    end

  end
end