require 'rspec/expectations'
require 'toni'

module Toni
  module RSpecHelper
    extend RSpec::Matchers::DSL

    def with_user(user, &block)
      Toni.current_user = user
      result = yield
      Toni.current_user = nil
      result
    end

    def without_authorization(&block)
      Toni.without_authorization(&block)
    end

    matcher :have_permission_on do |resource_or_name, options = {}|
      match do |user|
        with_user(user) do
          [*options[:to]].all? { |a| Toni.permitted_to?(a, resource_or_name) }
        end
      end
    end
  end
end