require 'sinatra/base'

module Toni
  module Sinatra
    module AuthorizationHelper
      def permitted_to(activity, resource_or_name, options={}, &block)
        options[:bang] = true unless options.key?(:bang)
        if Toni.permitted_to?(activity, resource_or_name, options)
          block.call if block_given?
        end
      end

      def without_authorization(&block)
        Toni.without_authorization(&block)
      end
    end

    module AuthorizationErrorHandler
      def not_authorized(&block)
        error do
          if env['sinatra.error'].instance_of? Toni::NotAuthorizedError
            instance_exec env['sinatra.error'], &block if block_given?
          end
        end
      end
    end

    def self.registered(app)
      app.helpers   AuthorizationHelper
      app.register  AuthorizationErrorHandler
    end
  end
end